diff --git a/charts/cp-schema-registry/templates/deployment.yaml b/charts/cp-schema-registry/templates/deployment.yaml
index d226d3a..4684cc8 100644
--- a/charts/cp-schema-registry/templates/deployment.yaml
+++ b/charts/cp-schema-registry/templates/deployment.yaml
@@ -33,10 +33,36 @@ spec:
       {{- end }}
       {{- end }}
     spec:
+      {{- if .Values.oauth.enabled }}
+      initContainers:
+      - name: init-certs
+        image: "{{ .Values.image.repository }}@{{ .Values.image.digest }}"
+        imagePullPolicy: "{{ .Values.imagePullPolicy }}"
+        command:
+          - /bin/bash
+          - '-ec'
+          - |-
+{{ include "cp-schema-registry.certImport" .Values.oauth.kafkaTls | indent 12 }}
+{{ include "cp-schema-registry.certImport" .Values.oauth.oauthTls | indent 12 }}
+        env:
+          - name: TRUSTSTORE_PASSWORD
+            valueFrom:
+              secretKeyRef:
+                name: {{ template "cp-schema-registry.fullname" . }}
+                key: truststore-password
+        volumeMounts:
+          - name: shared-certs
+            mountPath: /shared-certs
+{{ include "cp-schema-registry.certVolumeMount" .Values.oauth.kafkaTls | indent 10 }}
+{{ include "cp-schema-registry.certVolumeMount" .Values.oauth.oauthTls | indent 10 }}
+      {{- end }}
+      # this disables service discovery env vars that are not used and might conflict with
+      # config env vars (e.g.: SCHEMA_REGISTRY_PORT)
+      enableServiceLinks: false
       containers:
         {{- if .Values.prometheus.jmx.enabled }}
         - name: prometheus-jmx-exporter
-          image: "{{ .Values.prometheus.jmx.image }}:{{ .Values.prometheus.jmx.imageTag }}"
+          image: "{{ .Values.prometheus.jmx.repository }}@{{ .Values.prometheus.jmx.digest }}"
           imagePullPolicy: "{{ .Values.prometheus.jmx.imagePullPolicy }}"
           command:
           - java
@@ -57,7 +83,7 @@ spec:
             mountPath: /etc/jmx-schema-registry
         {{- end }}
         - name: {{ template "cp-schema-registry.name" . }}-server
-          image: "{{ .Values.image }}:{{ .Values.imageTag }}"
+          image: "{{ .Values.image.repository }}@{{ .Values.image.digest }}"
           imagePullPolicy: "{{ .Values.imagePullPolicy }}"
           ports:
             - name: schema-registry
@@ -100,6 +126,32 @@ spec:
           - name: JMX_PORT
             value: "{{ .Values.jmx.port }}"
           {{- end }}
+          {{- if .Values.oauth.enabled }}
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SECURITY_PROTOCOL
+            value: SASL_SSL
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SSL_TRUSTSTORE_LOCATION
+            value: {{ template "cp-schema-registry.trustStore" . }}
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SSL_TRUSTSTORE_PASSWORD
+            valueFrom:
+              secretKeyRef:
+                name: {{ template "cp-schema-registry.fullname" . }}
+                key: truststore-password
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SSL_TRUSTSTORE_TYPE
+            value: PKCS12
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SASL_MECHANISM
+            value: OAUTHBEARER
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SASL_JAAS_CONFIG
+            valueFrom:
+              secretKeyRef:
+                name: {{ template "cp-schema-registry.fullname" . }}
+                key: jaas-config
+          - name: SCHEMA_REGISTRY_KAFKASTORE_SASL_LOGIN_CALLBACK_HANDLER_CLASS
+            value: io.strimzi.kafka.oauth.client.JaasClientOauthLoginCallbackHandler
+          volumeMounts:
+          - name: shared-certs
+            mountPath: /shared-certs
+            readOnly: true
+          {{- end }}
       {{- if .Values.imagePullSecrets }}
       imagePullSecrets:
 {{ toYaml .Values.imagePullSecrets | indent 8 }}
@@ -110,6 +162,12 @@ spec:
         configMap:
           name: {{ template "cp-schema-registry.fullname" . }}-jmx-configmap
       {{- end }}
+      {{- if .Values.oauth.enabled }}
+      - name: shared-certs
+        emptyDir: {}
+{{ include "cp-schema-registry.certVolume" .Values.oauth.kafkaTls | indent 6 }}
+{{ include "cp-schema-registry.certVolume" .Values.oauth.oauthTls | indent 6 }}
+      {{- end }}
       {{- if .Values.nodeSelector }}
       nodeSelector:
 {{ toYaml .Values.nodeSelector | indent 8 }}
